<script lang="ts">
  import {
    Dialog,
    DialogBody,
    DialogFooter,
    DialogHeader,
  } from 'components/Dialog';
  import Modal from 'components/Modal';
  import TextInput from 'components/TextInput';
  import Select from 'components/Select';
  import {
    COLUMN_OPTIONS,
    ISSUE_TYPE_OPTIONS,
    PRIORITY_OPTIONS,
  } from 'constants/issue';
  import priorityIconByValue from 'utils/priorityIconByValue';
  import { mutation } from '@urql/svelte';
  import {
    Column,
    CreateIssueDocument,
    type CreateIssueMutation,
    type CreateIssueMutationVariables,
    DeleteIssueDocument,
    type DeleteIssueMutation,
    type DeleteIssueMutationVariables,
    IssueType,
    Priority,
    UpdateIssueDocument,
    type UpdateIssueMutation,
    type UpdateIssueMutationVariables,
  } from 'generated/graphql';
  import issueTypeIconByValue from 'utils/issueTypeIconByValue';
  import {
    collaborators,
    firstIssueCreated,
    kanbanId,
    userId,
  } from 'stores/authStore';
  import { issues } from 'stores/kanbanStore';
  import DeleteIcon from 'icons/DeleteIcon';

  export let show;
  export let onClose;

  export let id = '';
  export let shortId = '';
  export let issueType = IssueType.Task;
  export let summary = '';
  export let description = '';
  export let priority = Priority.Medium;
  export let column = Column.Todo;
  export let assigneeId = null;
  export let createdAt = null;
  export let updatedAt = null;

  const createIssueMutation = mutation<CreateIssueMutation, CreateIssueMutationVariables>({ query: CreateIssueDocument });
  const updateIssueMutation = mutation<UpdateIssueMutation, UpdateIssueMutationVariables>({ query: UpdateIssueDocument });
  const deleteIssueMutation = mutation<DeleteIssueMutation, DeleteIssueMutationVariables>({ query: DeleteIssueDocument });

  const handleDelete = async () => deleteIssueMutation({ issueId: id });

  const handleSubmit = async () => {
    const commonVariables = {
      authorId: $userId,
      kanbanId: $kanbanId,
      data: {
        assigneeId,
        column,
        description,
        issueType,
        priority,
        summary,
      },
    };
    if (isUpdate) {
      await updateIssueMutation({
        ...commonVariables,
        issueId: id,
      });
    } else {
      const res = await createIssueMutation(commonVariables);
      if (!res.error && $issues.length === 0) $firstIssueCreated = Date.now();
    }

    onClose();
  };

  $: isUpdate = Boolean(id);
  
  $: assigneeOptions = $collaborators?.map((collaborator) => ({ value: collaborator.id, label: collaborator.name })) || [];
</script>

<Modal {show}>
  <Dialog>
    <DialogHeader {onClose}>{isUpdate ? `Issue ${shortId}` : 'Create issue'}</DialogHeader>
    <form class="w-full" on:submit|preventDefault={handleSubmit}>
      <DialogBody>
        <div class="mb-6">
          <Select
            bind:value={issueType}
            id="issueType"
            label="Issue type"
            options={ISSUE_TYPE_OPTIONS}
            required="true"
            hasIcon={Boolean(issueTypeIconByValue(issueType))}
          >
            <svelte:component this={issueTypeIconByValue(issueType)} />
          </Select>
        </div>
        <div class="mb-6">
          <TextInput
            bind:value={summary}
            id="summary"
            label="Summary"
            placeholder="Name your issue"
            required="true"
          />
        </div>
        <div class="mb-6">
          <TextInput
            bind:value={description}
            id="description"
            label="Description"
            placeholder="Describe issue"
            required="true"
            multiline="true"
          />
        </div>
        <div class="mb-6">
          <Select
            bind:value={priority}
            id="priority"
            label="Priority"
            options={PRIORITY_OPTIONS}
            required="true"
            hasIcon={Boolean(priorityIconByValue(priority))}
          >
            <svelte:component this={priorityIconByValue(priority)} />
          </Select>
        </div>
        <div class="mb-6">
          <Select
            bind:value={column}
            id="column"
            label="Column"
            options={COLUMN_OPTIONS}
            required="true"
          />
        </div>
        <div class="mb-6">
          <Select
            bind:value={assigneeId}
            id="assignee"
            label="Assignee"
            options={assigneeOptions}
          />
        </div>
        {#if isUpdate}
          <p class="block pb-2 text-sm font-medium text-gray-900 dark:text-gray-400">Created at: {new Date(createdAt).toLocaleString()}</p>
          <p class="block pb-2 text-sm font-medium text-gray-900 dark:text-gray-400">Updated at: {new Date(updatedAt).toLocaleString()}</p>
        {/if}
      </DialogBody>
      <DialogFooter>
        <div class="w-full flex {isUpdate ? 'justify-between' : 'justify-end'}">
          {#if isUpdate}
            <button
              on:click={handleDelete}
              class="text-gray-500 hover:bg-gray-100 border hover:bg-red-700 hover:text-white focus:ring-4
              focus:outline-none focus:ring-red-300 font-medium rounded-lg text-sm p-2.5 text-center inline-flex
              items-center mr-2 dark:border-gray-500 dark:text-gray-500 dark:hover:text-white dark:focus:ring-red-800">
              <DeleteIcon />
            </button>
          {/if}
          <div>
            <button
              on:click={onClose}
              class="text-gray-500 bg-white hover:bg-gray-100 focus:ring-4 focus:outline-none focus:ring-blue-300 rounded-lg
                border border-gray-200 text-sm font-medium px-5 py-2.5 hover:text-gray-900 focus:z-10 dark:bg-gray-700
                dark:text-gray-300 dark:border-gray-500 dark:hover:text-white dark:hover:bg-gray-600 dark:focus:ring-gray-600"
            >
              Cancel
            </button>
            <button
              type="submit"
              class="text-white bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium
                rounded-lg text-sm px-5 py-2.5 text-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800"
            >
              {isUpdate ? 'Save changes' : 'Create'}
            </button>
          </div>
        </div>
      </DialogFooter>
    </form>
  </Dialog>
</Modal>
